#include <stdio.h>
#include "cuda.h"
#include "cuda_runtime_api.h" 
#include<sys/time.h>

__global__ void interp_on_CUDA(int num_threads, int n_fine,int* CF_marker,int* jj_count, int* fine_to_coarse, int* coarse_counter, int* S_diag_i,int* S_diag_j, int* S_offd_i, int* S_offd_j, int* CF_marker_offd,int* jj_count_offd,int* col_offd_S_to_A,int num_procs)
   {
     int size,rest,i,ne,ns,j,jj,i1;
     
     	j = blockIdx.x * blockDim.x + threadIdx.x;


        

    
     size = n_fine/num_threads;
     rest = n_fine - size*num_threads;
     if (j < rest)
     {
        ns = j*size+j;
        ne = (j+1)*size+j+1;
     }
     else
     { 
        ns = j*size+rest;
        ne = (j+1)*size+rest;
     }


 

     for (i = ns; i < ne; i++)
     {
      
    

      if (CF_marker[i] >= 0)
      {
         jj_count[j]++;
         fine_to_coarse[i] = coarse_counter[j];
         coarse_counter[j]++;
      }
      
    

      else
      {
         for (jj = S_diag_i[i]; jj < S_diag_i[i+1]; jj++)
         {
            i1 = S_diag_j[jj];           
            if (CF_marker[i1] >= 0)
            {
               jj_count[j]++;
            }
         }

         if (num_procs > 1)
         {
	   if (col_offd_S_to_A)
           {
            for (jj = S_offd_i[i]; jj < S_offd_i[i+1]; jj++)
            {
               i1 = col_offd_S_to_A[S_offd_j[jj]];           
               if (CF_marker_offd[i1] >= 0)
               {
                  jj_count_offd[j]++;
               }
            }
           }
           else
           {
            for (jj = S_offd_i[i]; jj < S_offd_i[i+1]; jj++)
            {
               i1 = S_offd_j[jj];           
               if (CF_marker_offd[i1] >= 0)
               {
                  jj_count_offd[j]++;
               }
            }
           }
         }
      }
    }



   }


extern "C"
{

void runcudaonkernel(int num_threads, int n_fine,int* CF_marker,int* jj_count, int* fine_to_coarse, int* coarse_counter, int* S_diag_i,int* S_diag_j, int* S_offd_i, int* S_offd_j, int* CF_marker_offd,int* jj_count_offd,int* col_offd_S_to_A,int num_procs)
{
   

  int* cCF_marker,*cjj_count, *cfine_to_coarse, *ccoarse_counter, *cS_diag_i,*cS_diag_j, *cS_offd_i, *cS_offd_j, *cCF_marker_offd,*cjj_count_offd, *ccol_offd_S_to_A;
   int size,rest,i,ne,ns;
   int indexlength;
     
     
   
     size = n_fine/num_threads;
     rest = n_fine - size*num_threads;

    if ((num_threads-1) < rest)
     {
      
        ne = num_threads*size+num_threads;
     }
     else
     {
       
        ne = (num_threads)*size+rest;
     }      



     cudaMalloc((void**)&cCF_marker, n_fine*sizeof(int));
     cudaMalloc((void**)&cjj_count, num_threads*sizeof(int));
     cudaMalloc((void**)&cfine_to_coarse,n_fine*sizeof(int));
     cudaMalloc((void**)&ccoarse_counter,num_threads*(sizeof(int)));
     cudaMalloc((void**)&cS_diag_i,n_fine*sizeof(int));
     cudaMalloc((void**)&cS_diag_j,n_fine*sizeof(int));

     if(S_offd_j[ne] > n_fine)
     printf("Unbalanced\n");
   

      if(num_procs > 1)
     {
      if(col_offd_S_to_A)
     {
      indexlength = col_offd_S_to_A[S_offd_j[S_offd_i[ne]]];
     }
     else
     {
	indexlength =  S_offd_j[ne];
 
     }	
    
     cudaMalloc((void**)&cCF_marker_offd,indexlength*sizeof(int));
     cudaMalloc((void**)&cjj_count_offd, sizeof(int)*num_threads);
     cudaMalloc((void**)&ccol_offd_S_to_A,sizeof(int)*S_offd_j[S_offd_i[ne]]);
     cudaMalloc((void**)&cS_offd_i,n_fine*sizeof(int));
     cudaMalloc((void**)&cS_offd_j,n_fine*sizeof(int));       

     cudaMemcpy(cS_offd_i,S_offd_i,n_fine*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(cS_offd_j,S_offd_j,n_fine*sizeof(int),cudaMemcpyHostToDevice);

     cudaMemcpy(cCF_marker_offd,CF_marker_offd,indexlength*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(cjj_count_offd,jj_count_offd,sizeof(int)*num_threads,cudaMemcpyHostToDevice);
     cudaMemcpy(ccol_offd_S_to_A,col_offd_S_to_A,sizeof(int)*S_offd_j[S_offd_i[ne]],cudaMemcpyHostToDevice);

    }
    else
   {
     
     cudaMalloc((void**)&cCF_marker_offd,sizeof(int));
     cudaMalloc((void**)&cjj_count_offd, sizeof(int));
     cudaMalloc((void**)&ccol_offd_S_to_A,sizeof(int));
     cudaMalloc((void**)&cS_offd_i,sizeof(int));
     cudaMalloc((void**)&cS_offd_j,sizeof(int)); 


   }
   

     
    



      

     cudaMemcpy(cCF_marker,CF_marker,n_fine*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(cjj_count,jj_count, num_threads*sizeof(int),cudaMemcpyHostToDevice);
   
     cudaMemcpy(cfine_to_coarse,fine_to_coarse ,n_fine*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(cS_diag_i,S_diag_i,n_fine*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(cS_diag_j,S_diag_j,n_fine*sizeof(int),cudaMemcpyHostToDevice);
     cudaMemcpy(ccoarse_counter,coarse_counter,num_threads*sizeof(int),cudaMemcpyHostToDevice);

     
      interp_on_CUDA <<<1,num_threads>>> (num_threads,n_fine,cCF_marker,cjj_count, cfine_to_coarse, ccoarse_counter, cS_diag_i,cS_diag_j, cS_offd_i, cS_offd_j, cCF_marker_offd,cjj_count_offd,ccol_offd_S_to_A,num_procs);

      


     cudaMemcpy(fine_to_coarse,cfine_to_coarse,ne*sizeof(int),cudaMemcpyDeviceToHost);
     cudaMemcpy(coarse_counter,ccoarse_counter,num_threads*(sizeof(int)),cudaMemcpyDeviceToHost);
     cudaMemcpy(jj_count,cjj_count,num_threads*sizeof(int),cudaMemcpyDeviceToHost);
    if(num_procs > 1)
   {
    cudaMemcpy(jj_count_offd,cjj_count_offd,sizeof(int)*num_threads,cudaMemcpyDeviceToHost);
   } 


 
   


    cudaFree(cCF_marker);
    cudaFree(cjj_count);
    cudaFree(cCF_marker_offd);
    cudaFree(cjj_count_offd);
    cudaFree(ccol_offd_S_to_A);
    cudaFree(cfine_to_coarse);
    cudaFree(cS_diag_i);
    cudaFree(cS_offd_i);
    cudaFree(cS_diag_j);
     cudaFree(cS_offd_j);
     cudaFree(ccoarse_counter);

     
   return;

     


  


}


}


__global__ void miscinterp(int* fine_to_coarse,int* coarse_counter,int n_fine,int num_threads)
{
    int j,i,ns,ne,coarse_shift,size,rest;


      j = blockIdx.x * blockDim.x + threadIdx.x;
  
     coarse_shift = 0;
     if (j > 0) 
       coarse_shift = coarse_counter[j-1];
     size = n_fine/num_threads;
     rest = n_fine - size*num_threads;
     if (j < rest)
     {
        ns = j*size+j;
        ne = (j+1)*size+j+1;
     }
     else
     {
        ns = j*size+rest;
        ne = (j+1)*size+rest;
     }
     for (i = ns; i < ne; i++)
	fine_to_coarse[i] += coarse_shift;


}

extern "C"
{

long coarseshiftinterp(int* fine_to_coarse,int* coarse_counter,int n_fine, int num_threads)
{
    int size,rest,ne;
    int* cfine_to_coarse;
    int* ccoarse_counter;
      size = n_fine/num_threads;
     rest = n_fine - size*num_threads;
      if ((num_threads-1) < rest)
     {
       
        ne = (num_threads)*size+num_threads;
     }
     else
     {
        ne = num_threads*size+rest;
     }
         
    struct timeval curr_time;
    struct timeval elapsed_time;
    long int diff,seconds,useconds,diff1;

    gettimeofday(&curr_time, NULL);


    cudaMalloc((void**)&cfine_to_coarse,sizeof(int)*ne);
    cudaMalloc((void**)&ccoarse_counter,num_threads*sizeof(int));

    cudaMemcpy(cfine_to_coarse,fine_to_coarse,sizeof(int)*ne,cudaMemcpyHostToDevice);
    cudaMemcpy(ccoarse_counter,coarse_counter,sizeof(int)*num_threads,cudaMemcpyHostToDevice);

     //stop the timer
gettimeofday(&elapsed_time, NULL);

//find the elapsed time for pi calculation
seconds  = elapsed_time.tv_sec  - curr_time.tv_sec;
useconds = elapsed_time.tv_usec  - curr_time.tv_usec;
diff = seconds * 1000000 + useconds;

  
   
     miscinterp<<<1,num_threads>>>(cfine_to_coarse,ccoarse_counter,n_fine,num_threads);

       gettimeofday(&curr_time, NULL);


     cudaMemcpy(fine_to_coarse,cfine_to_coarse,sizeof(int)*ne,cudaMemcpyDeviceToHost);
   
    
    cudaFree(cfine_to_coarse);
    cudaFree(ccoarse_counter);

      gettimeofday(&elapsed_time, NULL);

//find the elapsed time for pi calculation
seconds  = elapsed_time.tv_sec  - curr_time.tv_sec;
useconds = elapsed_time.tv_usec  - curr_time.tv_usec;
diff1 = seconds * 1000000 + useconds;

    // printf("Cudacall diff %ld iterations %d\n",diff+diff1,n_fine);
     return (diff+diff1);
    

}
  

}


__global__ void BinarySearchOnCuda(int* list ,int* value ,int list_length,int* result,int size)
{


   int low, high, m,i,j;
   int not_found = 1;


    j = blockIdx.x * blockDim.x + threadIdx.x;
  

  for(i=j*size; i <(j+1)*size; i++)
  {
   not_found = 1;
   low = 0;
   high = list_length-1; 
   while (not_found && low <= high)
   {
      m = (low + high) / 2;
      if (value[j] < list[m])
      {
         high = m - 1;
      }
      else if (value[j] > list[m])
      {
        low = m + 1;
      }
      else
      {
        not_found = 0;
        result[i] = m;
        break;
      }
   }
   if(not_found !=0)
   result[i] = -1;

  }
  

}

extern "C"
{
 int BinarySearchOnCudaCaller(int* list, int* value,int list_length,int value_length)
{
   int i;
   int num_threads;
    
   int* cudalist;
   int* cudacompare;
   int* cudaresult; 
   int z=0;


    num_threads = 10;
   int size = value_length/num_threads;

 
   if(size == 0 || (value_length%num_threads !=0))
   {
      return -1;
   }
   else
   {

  
   cudaMalloc((void**)&cudalist,list_length*sizeof(int));
   cudaMalloc((void**)&cudacompare, value_length*sizeof(int));
   cudaMalloc((void**)&cudaresult,value_length*sizeof(int));
   
   cudaMemcpy(cudalist,list,list_length*sizeof(int),cudaMemcpyHostToDevice);
   cudaMemcpy(cudacompare,value,value_length*sizeof(int),cudaMemcpyHostToDevice);


   BinarySearchOnCuda <<<1,num_threads>>>(cudalist,cudacompare,list_length,cudaresult,size);

    


   cudaMemcpy(value,cudaresult,value_length*sizeof(int),cudaMemcpyDeviceToHost); 

   cudaFree(cudalist);
   cudaFree(cudacompare);
   cudaFree(cudaresult);
   return 0;
   }

}

}

extern "C"
{
 int BinarySearchOnCudaCallerDif(int* list, int* value,int list_length,int value_length,int* result)
{
   int i;
   int num_threads;
    
   int* cudalist;
   int* cudacompare;
   int* cudaresult; 
   int z=0;


    num_threads = 10;
   int size = value_length/num_threads;

 
   if(size == 0 || (value_length%num_threads !=0))
   {
      return -1;
   }
   else
   {

  
   cudaMalloc((void**)&cudalist,list_length*sizeof(int));
   cudaMalloc((void**)&cudacompare, value_length*sizeof(int));
   cudaMalloc((void**)&cudaresult,value_length*sizeof(int));
   
   cudaMemcpy(cudalist,list,list_length*sizeof(int),cudaMemcpyHostToDevice);
   cudaMemcpy(cudacompare,value,value_length*sizeof(int),cudaMemcpyHostToDevice);


   BinarySearchOnCuda <<<1,num_threads>>>(cudalist,cudacompare,list_length,cudaresult,size);

    


   cudaMemcpy(result,cudaresult,value_length*sizeof(int),cudaMemcpyDeviceToHost); 

   cudaFree(cudalist);
   cudaFree(cudacompare);
   cudaFree(cudaresult);
   return 0;
   }

}


}



